@echo off

REM Environment variables
SET MAMELOCATION=C:\MAME
SET INPLOCATION=%MAMELOCATION%\inp
SET DOWNLOCATION=C:\MAME\inp\MARP
SET DONELOCATION=C:\MAME\inp\MARP\Done
SET DOSBOXEXE=C:\Program Files\DOSBox-0.74\DOSBox.exe
SET DOSBOXCONF=%MAMELOCATION%\dosbox.conf
SET ZIP=C:\Program Files\7-Zip\7z.exe
SET ZIPFLAGS=e -y -o%DOWNLOCATION%

REM Get current working directory
cd>%MAMELOCATION%\cwd.txt
SET /P CWD=<%MAMELOCATION%\cwd.txt

REM Backup current configuration for game
if exist cfg\%1.cfg move cfg\%1.cfg cfg\%1.bak
if exist hi\%1.hi move hi\%1.hi hi\%1.bak
if exist nvram\%1.nv move nvram\%1.nv nvram\%1.bak
if exist diff\%1.dif move diff\%1.dif diff\%1.bak

REM Extract the zip file
"%ZIP%" %ZIPFLAGS% %DOWNLOCATION%\*.zip
cd "%DOWNLOCATION%"
RENAME *.inp %2.inp
RENAME *.wlf %2.wlf
cd %CWD%
MOVE "%DOWNLOCATION%\%2.inp" "%INPLOCATION%\"
IF EXIST "%DOWNLOCATION%\%2.wlf" MOVE "%DOWNLOCATION%\%2.wlf" "%INPLOCATION%\"

REM Work out the version of MAME
SET MEXE=%1
SET MVER=%1
IF "%MVER:~2,1%" == "b" GOTO MVERTHIRD
IF "%MVER:~2,1%" == "u" GOTO MVERTHIRD
IF "%MVER:~3,1%" == "u" GOTO MVERFOURTH
GOTO MVERNUMERIC

REM 91u1, for example
:MVERTHIRD
SET MVER=%MVER:~0,2%
GOTO MVERNUMERIC

REM 102u1, for example
:MVERFOURTH
SET MVER=%MVER:~0,3%
GOTO MVERNUMERIC

:MVERNUMERIC
ECHO MAME Version %MVER%

REM Default to no -nvram_directory paramater
SET NVRAM=

REM Determine NVRAM options
IF %MVER% GTR 135 GOTO NVRAM
GOTO NONVRAM

:NVRAM
SET NVRAM=-nvram_directory NUL

:NONVRAM

REM Determine INP options
IF %MVER% GTR 100 GOTO WITHINP
SET INPNAME=%2
GOTO NOINP

:WITHINP
SET INPNAME=%2.inp

:NOINP
REM Determine game options
IF "%3" == "" GOTO DEFAULTGAME
SET GAME=%3
GOTO HAVEGAME

:DEFAULTGAME
SET GAME=%2

:HAVEGAME

IF %MVER% GTR 37 GOTO WINDOWS
REM Use DOSBox
SET MAMEEXE=M%MEXE%.EXE
IF NOT EXIST %MAMEEXE% GOTO WINDOWS
COPY %DOSBOXCONF% TEMP.CONF
echo MOUNT C: %MAMELOCATION%>>TEMP.CONF
echo C:>>TEMP.CONF
echo %MAMEEXE% %GAME% -fs 0 -playback %GAME% -soundcard 1 %3 %4 %5 %6 %7 %8 %9>>TEMP.CONF
echo exit>>TEMP.CONF
GOTO RUNDOSBOX

:RUNDOSBOX
"%DOSBOXEXE%" -conf TEMP.CONF
GOTO CLEANUP

:WINDOWS
SET MAMEEXE=mame%MEXE%.EXE
IF NOT EXIST %MAMEEXE% GOTO MISSINGMAME
IF %MVER% GTR 84 GOTO WITHIV
REM Check for early WolfMAMEs with mameplib.dll requirement
REM Assumes the relevant mameplib.dll will exist as mamep<ver>lib.dll like the newer ones.
IF %MVER% GTR 82 GOTO PLIBDONE
IF EXIST mameplib.dll DEL mameplib.dll
SET MLIB=mamep%MVER%lib.dll
IF EXIST %MLIB% COPY %MLIB% mameplib.dll

:PLIBDONE
%MAMEEXE% -w -nomax -nothrottle -playback %INPNAME% %GAME% %4 %5 %6 %7 %8 %9 %NVRAM%
GOTO CLEANUP

:WITHIV
%MAMEEXE% -w -nomax -nothrottle -iv 1 -playback %INPNAME% %GAME% %4 %5 %6 %7 %8 %9 %NVRAM%
GOTO CLEANUP

:CLEANUP
if exist cfg\%1.bak move cfg\%1.bak cfg\%1.cfg
if exist hi\%1.bak move hi\%1.bak hi\%1.hi
if exist nvram\%1.bak move nvram\%1.bak nvram\%1.nv
if exist diff\%1.bak move diff\%1.bak diff\%1.dif
if exist %INPLOCATION%\%2.inp del %INPLOCATION%\%2.inp
if exist %INPLOCATION%\%2.wlf del %INPLOCATION%\%2.wlf
del %DOWNLOCATION%\*.png>NUL
move "%DOWNLOCATION%\*.zip" "%DONELOCATION%\"
GOTO EOF

:MISSINGMAME
echo MAME executable (%MAMEEXE%) not found.
GOTO EOF

:EOF